<?php 
/* 
 * 	  © Copyright 2010 WALTHER Jérémy & MOLE Bruno
 *    Zoku Server
 *    Version 1.0-beta
 *    
 *    Contact the authors :
 *    WALTHER Jérémy	: jeremy.walther@ftad.fr
 *    MOLE Bruno		: bruno.mole@ftad.fr
 *    
 *    This file is part of Zoku Server.
 *
 *    Zoku Server is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    Zoku Server is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with Zoku Server.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
?>
<?php

// Auteur: WALTHER Jérémy (golflima@ftad.fr)
// Design: WALTHER Jérémy (golflima@ftad.fr)
// Création : 26/03/2010
// Révision : 28/03/2010
// Fonction : Génération d'une carte membre (génération du code à barres)

$zs_site_root = dirname(dirname(__FILE__))."/"; // server root
include $zs_site_root."system/includes.php";

$zs_dblink = new ZS_MySQLLink();
if(isset($zs_mysql_ressource))
{
	$zs_dblink->setConnection($zs_mysql_ressource);
}
else
{
	$zs_dblink->Connect($zs_db_host, $zs_db_user, $zs_db_pass, $zs_db_name);
}

// Unsetting critical vars ...
unset($zs_db_user);
unset($zs_db_pass);
unset($zs_db_host);
unset($zs_db_name);

if(isset($_GET['id']) && isset($_GET['hash']))
{
	if($_GET['id'] != "" && $_GET['hash'] != "")
	{
		$card_id = zs_noSQL($_GET['id']);
		$hash = zs_noSQL($_GET['hash']);
		
		$card = new ZS_Card();
		
		if($card->selectById($card_id))
		{
			if($hash == $card->generateHash())
			{
				$group = new ZS_Group();
				if($group->selectById($card->group_id))
				{
					$card_key = substr($card->key, 0, 2) . " " . substr($card->key, 2, 5) . " " . substr($card->key, 7, 5) . " " . substr($card->key, 12, 2);
					
					//$birthdate = date("d/m/Y", $card->birthdate);
					$birthdate = $card->birthdate;
					/*while(strlen($card_id) < 7)
					{
						$card_id = "0".$card_id;
					}
					while(strlen($card_key) < 3)
					{
						$card_key = "0".$card_key;
					}
					
					$card_number = "";
					for($i = 0; ($i * 3) < strlen($card_barcode); $i++)
					{
						$card_number .= substr($card_barcode, $i * 3, 3)." ";
					}*/
					
					$varstoput = array(	'key'			=>	$card->key,
										'first_name'	=>	$card->first_name,
										'last_name'		=>	$card->last_name,
										'birthdate'		=>	$birthdate,
										'type'			=>	$card->type);
					
					/*$card_barcode = "<ZokuCard>\n";
					foreach ($varstoput as $key => $value)
					{
						$card_barcode .= "<".$key.">".$value."</".$key.">\n";
					}
					$card_barcode .= "</ZokuCard>";*/
					
					$card_barcode = "";
					foreach ($varstoput as $key => $value)
					{
						$card_barcode .= $value."\n";
					}
					
					$card_hash = "<Zoku>";
					foreach ($varstoput as $key => $value)
					{
						$card_hash .= $value."|";
					}
					$card_hash = md5($card_hash."</Zoku>");
					
					$card_barcode .= $card_hash."\n";
			
					header("Content-type: image/png;");
					header("Content-Disposition: inline; filename=Card_$card->key.png"); 
			
					$px_per_mm = 10; // ~300ppp
			
					//$card = imagecreate(856, 540);
			
					// On utilise l'API Chart de Google pour générer le code 2D QR correspondant
					copy("http://chart.apis.google.com/chart?cht=qr&chs=300x300&chld=L|0&chl=".urlencode(utf8_encode($card_barcode))."&choe=UTF-8", "$zs_site_root/temp/barcode_$card->key.png");
					$qrcode = ImageCreateFromPNG("$zs_site_root/temp/barcode_$card->key.png");
					$width_qr = ImagesX($qrcode);
					$height_qr = ImagesY($qrcode);
					
					// Si une photo est définie, alors on la colle automatiquement
					$use_photo = false;
					if (!empty($card->photo) && trim($card->photo) != "")
					{
						$split_photo_url = explode(".", $card->photo);
						$photo_ext = strtolower($split_photo_url[count($split_photo_url) - 1]);
						$photo_name = "$zs_site_root/temp/photo_$card->key";
						try
						{
							switch ($photo_ext)
							{
								case "jpg" : 
									copy(htmlspecialchars_decode($card->photo), $photo_name.".".$photo_ext);
									$photo_full = ImageCreateFromJPeG($photo_name.".".$photo_ext);
									$use_photo = true;
									break;
								case "jpeg" : 
									copy(htmlspecialchars_decode($card->photo), $photo_name.".".$photo_ext);
									$photo_full = ImageCreateFromJPeG($photo_name.".".$photo_ext);
									$use_photo = true;
									break;
								case "png" :
									copy(htmlspecialchars_decode($card->photo), $photo_name.".".$photo_ext);
									$photo_full = ImageCreateFromPNG($photo_name.".".$photo_ext);
									$use_photo = true;
									break;
								case "gif" : 
									copy(htmlspecialchars_decode($card->photo), $photo_name.".".$photo_ext);
									$photo_full = ImageCreateFromGIF($photo_name.".".$photo_ext);
									$use_photo = true;
									break;
								default : // by default, it will be JPeG ^^
									$photo_ext = "jpg";
									copy(htmlspecialchars_decode($card->photo), $photo_name.".".$photo_ext);
									$photo_full = ImageCreateFromJPeG($photo_name.".".$photo_ext);
									$use_photo = true;
									break;
							}
						}
						catch (Exception $e)
						{
							$use_photo = false;
						}
						if ($use_photo)
						{
							// On redimensionne la photo pour la faire rentrer dans le cadre
							$photo = ImageCreateTrueColor(350, 450);
							ImageCopyResampled($photo, $photo_full, 0, 0, 0, 0, ImagesX($photo), ImagesY($photo), ImagesX($photo_full), ImagesY($photo_full));
							unset($photo_full);
						}
					}
			
					$card_img = ImageCreateFromPNG("$zs_site_root/images/backgrounds/FedeGN_Card.png");
					$width = ImagesX($card_img);
					$height = ImagesY($card_img);
			
					$orange = ImageColorAllocate($card_img, 255, 128, 0);
					$bleu = ImageColorAllocate($card_img, 0, 0, 255);
					$bleuclair = ImageColorAllocate($card_img, 156, 227, 254);
					$noir = ImageColorAllocate($card_img, 0, 0, 0);
					$blanc = ImageColorAllocate($card_img, 255, 255, 255);
			
					ImageColorTransparent($card_img, $orange);
			
					//imagestring($card, 2, 45, 500, $card_id." - ".$card_key, $noir);
			
					// Définission de la variable d'environnement pour GD
					putenv('GDFONTPATH=' . $zs_site_root. 'fonts');
			
					// Nom de la police à utiliser (notez l'absence de l'extension .ttf)
					$font = $zs_site_root. 'fonts/Folks-Normal.ttf';
					$font_title = $zs_site_root. 'fonts/FolksBlack.ttf';
					$font_assoc = $zs_site_root. 'fonts/KENYC___.ttf';
					
					$b = 60;
					ImageTTFText($card_img, 16, 0, 440 , $b = $b, $noir  , $font_title  , "Nom"); 
					ImageTTFText($card_img, 16, 0, 440 , $b = $b + 20, $noir  , $font  , " ".zs_strToUpper($card->last_name)); 
					ImageTTFText($card_img, 16, 0, 440 , $b = $b + 25, $noir  , $font_title  , "Prénom"); 
					ImageTTFText($card_img, 16, 0, 440 , $b = $b + 20, $noir  , $font  , " ".$card->first_name); 
					if (substr($card->gender, 0, 1) == "F")
					{
						ImageTTFText($card_img, 16, 0, 440 , $b = $b + 25, $noir  , $font_title  , "Née le"); 
					}
					else
					{
						ImageTTFText($card_img, 16, 0, 440 , $b = $b + 25, $noir  , $font_title  , "Né le"); 
					}
					ImageTTFText($card_img, 16, 0, 440 , $b = $b + 20, $noir  , $font  , " ".$birthdate); 
					
					//ImageTTFText($card_img, 16, 0, 440 , $b = $b, $noir  , $font_title  , "Association");
					// this is for local Test, OVH is creepy
					//ImageTTFText($card_img, 22, 89.7, 465 , 495, $noir  , $font_assoc  , $group->name); 
					ImageTTFText($card_img, 22, 89.7, 440 , 495, $noir  , $font_assoc  , zs_strToUpper($group->name)); 
			
					ImageTTFText($card_img, 22, 0, 45 , 527, $noir  , $font_title  , $card_key);
			
					ImageCopy($card_img, $qrcode, $width - $width_qr - 45, $height - $height_qr - 45, 0, 0, $width_qr, $height_qr);
					
					if ($use_photo)
					{
						ImageCopy($card_img, $photo, 45, 45, 0, 0, ImagesX($photo), ImagesY($photo));
					}
					
					ImagePNG($card_img);
			
					unlink("$zs_site_root/temp/barcode_$card->key.png");
					unlink("$zs_site_root/temp/photo_$card->key.$photo_ext");
				}
				else
				{
					die("ERROR : Cannot select this group.");
				}
			}
			else
			{
				die("ERROR : Invalid hash.");
			}
		}
		else
		{
			die("ERROR : Cannot select this card.");
		}
	}
	else
	{
		die("ERROR : ID and HASH must not be empty.");
	}
}
else
{
	die("ERROR : ID and HASH must be set.");
}

// close database connection
$zs_dblink->Close();

?>